/* Introduce the management of stack frames, that is, using rbp. */
    .section .data
    .section .text
    .global main
add:
    pushq   %rbx
    movq    %rdi, %rbx
    movq    $0, %rcx
    cmp     %rsi, %rcx
    jne     add_p
    popq    %rbx
    ret
add_p:
    incq    %rdi
    decq    %rsi
    cmp     %rsi, %rcx
    jne     add_p
    movq    %rdi, %rax
    popq    %rbx
    ret

adds:
    pushq   %rbp
    movq    %rsp, %rbp
    movq    16(%rbp), %rdi /* Load first arg */
    movq    24(%rbp), %rsi /* Load 2nd arg */
    call    add
    popq    %rbp
    ret

main:
    pushq   %rbp
    movq    %rsp, %rbp
    pushq   $4
    pushq   $5
    call    adds
	movq    %rbp, %rsp
    popq    %rbp
    ret
