    .section .data
    .section .text
    .global main
add: /* Arguments in rdi and rsi */
    pushq   %rbx
    movq    %rdi, %rbx
    movq    $0, %rcx
    cmp     %rsi, %rcx
    jne     add_p
    popq    %rbx
    ret
add_p:
    incq    %rdi
    decq    %rsi
    cmp     %rsi, %rcx
    jne     add_p
    movq    %rdi, %rax
    popq    %rbx
    ret

addv: /* rdi contains the number of arguments */
    /* r11 : accumulator, r13: adress of next arg, r12, number of rem args */
    pushq   %rbp
    movq    %rsp, %rbp
    movq    %rdi, %r12
    movq    %rbp, %r13 /* Store adress of next arg in r13 */
    addq    $8, %r13
    movq    $0, %r11 /* Init accumulator */
addv_l:
    addq    $8, %r13 /* Go to next arg */
    movq    (%r13), %rsi
    movq    %r11, %rdi
    call    add
    movq    %rax, %r11
    decq    %r12
    jg      addv_l
    movq    %r11, %rax
    movq    %rsp, %rbp /* Remove the allocated space */
    popq    %rbp
    ret

main:
    pushq   %rbp
    movq    %rsp, %rbp
    pushq   $4
    pushq   $6
    pushq   $7
    pushq   $3
    movq    $4, %rdi
    call    addv
	movq    %rbp, %rsp
    popq    %rbp
    ret
